//======================================================
// LCD\֐
// LCDfunc.c
//======================================================
#include "sfr26.h"     // OAKS16p`t@C
#include "LCDfunc.h"   // LCD\֐

#define PORTIN 0x00    // |[gWX^͂ɐݒ
#define	PORTOUT 0xff   // |[gWX^o͂ɐݒ
#define	LCDRS p8_7     // RS[q
#define	LCDRW p8_6     // RW[q
#define	LCDE p8_5      // E[q
#define	HIGH 1         // [qógHh
#define	LOW 0          // [qógLh
#define	LCD_COMMAND 0  // RS-commandw
#define	LCD_DATA 1     // RS-dataw
#define	BUSY 1         // LCDbusy
#define	NOBUSY 0       // LCDOK
#define	CHECKBUSY 1    // LCDbusy`FbN
#define	NOCHECKBUSY 0  // LCDbusy`FbNȂ

//======================================================
// gp֐
//======================================================
void lcdwriteinit( unsigned char command ); // LCD
void lcdwrite1command( unsigned char command, unsigned char flag ); // LCD1R}ho
void lcdwrite1data( unsigned char data, unsigned char flag ); // LCD1f[^o
void wait1( void ); // 0.1msEGCg
void wait2( void ); // 4.1msEGCg
void wait3( void ); // 15msEGCg
unsigned char lcdbusycheck( void ); // LCDrW[`FbN

//======================================================
// O[oϐ
//======================================================
unsigned char display_stat; // LCDɑ\[hێ

//======================================================
// ֐FLCD_init()
// @\FLCDݒ
//======================================================
void LCD_init( void )
{
  p9 =  0x00;    // |[g9(LCD data )lݒ
  prc2 = HIGH;   // p9veNgWX^
  pd9 = PORTOUT; // |[g9o͂ɐݒ
  p8 =  0x00;    // |[g8(LCD data )lݒ
  pd8 = PORTOUT; // |[g8o͂ɐݒ
  
  // 4rbg~2̃f[^]ł悤ɐݒ
  wait3();                             // 15msEGCg
  lcdwriteinit( 0x03 );                // LCDt@NVZbg
  wait2();                             // 4.1msEGCg
  lcdwriteinit( 0x03 );                // LCDt@NVZbg
  wait1();                             // 0.1msEGCg
  lcdwriteinit( 0x03 );                // LCDt@NVZbg
  wait1();                             // 0.1msEGCg
  lcdwriteinit( 0x02 );                // LCDf[^4rbgɐݒ
  wait1();                             // 0.1msEGCg
  lcdwrite1command(0x28, NOCHECKBUSY); // 4bit2s5~7hbgɐݒ
  wait1();                             // 0.1msEGCg

  // ̌̓rW[`FbNĂf[^]
  lcdwrite1command(0x08, CHECKBUSY);   // \It
  lcdwrite1command(0x01, CHECKBUSY);   // \NA
  lcdwrite1command(0x06, CHECKBUSY);   // Gg[[hCNg
  lcdwrite1command(0x0f, CHECKBUSY);
  lcdwrite1command(0x14, CHECKBUSY);
  
  display_stat = 0x0f; // ݂̕\
}

//======================================================
// ֐FLCD_cls()
// @\FDDRAM̓eSďĈʒu(0,0)ɐݒ
//======================================================
void LCD_cls( void )
{
  lcdwrite1command( 0x01, CHECKBUSY );
}

//======================================================
// ֐FLCD_off()
// @\F\OFF
//======================================================
void LCD_off( void )
{
  display_stat = display_stat & 0xfb;
  lcdwrite1command( display_stat, CHECKBUSY );
}

//======================================================
// ֐FLCD_on()
// @\F\ON
//======================================================
void LCD_on( void )
{
  display_stat = display_stat | 0x04;
  lcdwrite1command( display_stat, CHECKBUSY );
}

//======================================================
// ֐FLCD_locate()
// @\FJ[\ʒu(x,y)ɎwB
// @@@cursor!=0ŁAJ[\\B
// @@@blink!=0ŁAJ[\ʒũLN^_
//======================================================
void LCD_locate( signed char x, signed char y,
		 unsigned char cursor, unsigned char blink )
{
  unsigned char DDRAMadrs;
  
  if ( x < 0 || x > 15 ) { return; }
  if ( y < 0 || y >  1 ) { return; }
  
  DDRAMadrs = x + 0x80;
  if ( y == 1 ) {
    DDRAMadrs = DDRAMadrs + 0x40;
  }
  lcdwrite1command( DDRAMadrs, CHECKBUSY );
  
  if ( cursor == 0 ) {
    display_stat = display_stat & 0xfd;
  } else {
    display_stat = display_stat | 0x02;
  }
  if ( blink == 0 ) {
    display_stat = display_stat & 0xfe;
  } else {
    display_stat = display_stat | 0x01;
  }
  lcdwrite1command( display_stat, CHECKBUSY );
}

//======================================================
// ֐FLCD_print()
// @\FJ[\ʒuɃLN^1o
//======================================================
void LCD_print( unsigned char c )
{
  lcdwrite1data( c, CHECKBUSY );
}

//======================================================
// ֐FLCD_print_str()
// @\F(0,0)ő32\B
//======================================================
void LCD_print_str( unsigned char str[] )
{
  int i;
  
  for ( i=0; i<32; i++ ) {
    if ( str[i] == '\0' ) {
      break;
    }
    if ( i == 0 ) {
      // 1sڐ擪AhXZbg
      lcdwrite1command ( 0x80, CHECKBUSY );
      
      // \łȂLN^
      if ( str[i] < ' ' || str[i] > '~' ) {
	// 󔒂\
	lcdwrite1data( ' ', CHECKBUSY );
      }
      else {
	// \
	lcdwrite1data( str[i], CHECKBUSY );
      }
    }
    if ( i == 16 ) {
      // 2sڐ擪AhXZbg
      lcdwrite1command( 0xc0, CHECKBUSY );
      
      // \łȂLN^
      if ( str[i] < ' ' || str[i] > '~' ) {
	// 󔒂\
	lcdwrite1data( ' ', CHECKBUSY );
      } else {
	// \
	lcdwrite1data( str[i], CHECKBUSY );
      }
    }
    if ( ( i > 0 && i < 16 ) || ( i > 16 && i < 32 ) ) {
      if ( str[i] < ' ' || str[i] > '~' ) {
	lcdwrite1data( ' ', CHECKBUSY );
      } else {
	lcdwrite1data( str[i], CHECKBUSY );
      }
    }
  }
}

//======================================================
// ֐Flcdwriteinit()
// @\FLCDݒR}hZbg					
//======================================================
void lcdwriteinit( unsigned char command )
{
  prc2 = HIGH;   // p9veNgWX^
  pd9 = PORTOUT; // p9o͂ɐݒ
  p8 =  0x00;    // |[g8(LCD data )lݒ
  
  command &= 0x0f; 
  // p8Rg[f[^Zbg
  //ijRW:0(Ww) RS:0(R}hwjE:0
  
  p9 = command; // p8Rg[f[^o
  LCDE = HIGH;  // E:1


  // Ԓ
#pragma ASM     // AZu\L
  NOP
    NOP
    NOP
    NOP
#pragma ENDASM  // AZu\LI
    
    LCDE = LOW; // E:0
}

//======================================================
// ֐Flcdwrite1command()						
// @\FLCDR}ho							
//======================================================
void lcdwrite1command( unsigned char command, unsigned char flag )
{
  unsigned char outcommand;

  if ( flag == CHECKBUSY ) {
    while ( lcdbusycheck() == BUSY ) {}		//LCDrW[`FbN
  }
  
  prc2 = HIGH;              // p9veNgWX^
  pd9 = PORTOUT;            // p9o͂ɐݒ
  p8 = 0x00;                // p8lZbg
  
  outcommand = command>>4;  // 4rbg4rbg
  outcommand &= 0x0f;       // }XN
  p9 = outcommand;          // R}hf[^4rbgo
  LCDE = HIGH;              // E:1

#pragma ASM     // AZu\L
  NOP           // Ԓ
    NOP
    NOP
    NOP
#pragma ENDASM  // AZu\LI
    
    LCDE = LOW; // E:0
  
  outcommand = command&0x0f; // R}hf[^4rbgo
  p9 = outcommand;           // R}hf[^4rbgo
  LCDE = HIGH;               // E:1

#pragma ASM     // AZu\L
  NOP           // Ԓ
    NOP
    NOP
    NOP
#pragma ENDASM  // AZu\LI
    
    LCDE = LOW; // E:0
}

//======================================================
// ֐Flcdwrite1data()
// @\FLCDf[^o
//======================================================
void lcdwrite1data( unsigned char data, unsigned char flag )
{
  unsigned char lcddata;
  
  if ( flag == CHECKBUSY ) {
    while ( lcdbusycheck() == BUSY ) {} //LCDrW[`FbN
  }
  
  prc2 = HIGH;		// p9veNgWX^
  pd9 = PORTOUT;	// p9o͂ɐݒ
  p8 = 0x00;		// p8lZbg
  
  lcddata = data>>4;	// LCDf[^4rbg4rbg
  lcddata &= 0x0f;	// }XN
  p9 = lcddata;		// LCDf[^4rbgo
  LCDRS = LCD_DATA;	// RS:1(f[^wj
  LCDE = HIGH;		// E:1

#pragma ASM		// AZu\L
  NOP			// Ԓ
    NOP
    NOP
    NOP
#pragma ENDASM		// AZu\LI
    
    LCDE = LOW;		// E:0
  
  lcddata =data & 0x0f;	// LCDf[^̉4rbgo(4rbg}XN)
  p9 = lcddata;		// LCDf[^4rbgo
  LCDRS = LCD_DATA;	// RS:1(f[^wj
  LCDE = HIGH;		// E:1

#pragma ASM		// AZu\L
  NOP			// Ԓ
    NOP
    NOP
    NOP
#pragma ENDASM		// AZu\LI
    
    LCDE = LOW;		// E:0
}

//======================================================
// ֐Fwait1()
// @\F0.1msEGCg
//======================================================
void wait1(void)
{
#pragma ASM		// AZu\L
  MOV.W #0FAH,A0	// 2TCN@JE^lZbg250
    //(2+8x+2)TCN*50ns=0.1ms@x=250iFAH)
    LOOP1:
    NOP			// 1TCN
    NOP			// 1TCN
    NOP			// 1TCN
    DEC.W	A0	// 1TCN
    JNZ	LOOP1		// 2/4TCN@[vIH
#pragma ENDASM		// AZu\LI
}

//======================================================
// ֐Fwait2()
// @\F4.1msEGCg
//======================================================
void wait2(void)
{
#pragma ASM			// AZu\L
	MOV.W 	#280AH,A0	// JE^lZbg10250
LOOP2:
	NOP
	NOP
	NOP
	DEC.W	A0
	JNZ	LOOP2		// [vIH
#pragma ENDASM			// AZu\LI
}

//======================================================
// ֐Fwait3()
// @\F15msEGCg
//======================================================
void wait3(void)
{
#pragma ASM			// AZu\L
	MOV.W 	#927CH,A0	// JE^lZbg37500
LOOP3:
	NOP
	NOP
	NOP
	DEC.W	A0
	JNZ	LOOP3		// [vIH
#pragma ENDASM			// AZu\LI
}

//======================================================
// ֐Flcdbusycheck()
// @\FLCDrW[`FbN
//======================================================
unsigned char lcdbusycheck( void )
{
  unsigned char command_high, command_low, b_data;
  
  prc2 = HIGH;		// p9veNgWX^
  pd9 = PORTIN;		// |[gWX^͂ɐݒ
  p8 = 0x00;		// p8lZbg
  LCDRW = HIGH;		// RW:1(Rw)
  LCDE = HIGH;		// E:1

#pragma ASM		// AZu\L
  NOP			// Ԓ
    NOP
    NOP
    NOP
#pragma ENDASM		// AZu\LI
    
    command_high = p9;	// p94rbgǂݍ
  LCDE = LOW;		// E:0
  
  command_high <<=4;	// 4rbgʂ
  command_high &= 0xf0;	// 4rbgo(4rbg}XN)
  LCDE = HIGH;		// E:1

#pragma ASM		// AZu\L
  NOP			// Ԓ
    NOP
    NOP
    NOP
#pragma ENDASM		// AZu\LI
	
    command_low = p9;	// R}h4rbgǂݍ
  LCDE = LOW;		// E:0

  command_low &= 0x0f;	// 4rbgo(4rbg}XN)
  b_data = command_high|command_low;	// 24rbgR}hf[^8rbg
  b_data &= 0x80;			// rbg7̃}XN
  if ( b_data == 0 ) {
    b_data = NOBUSY;	// rbg70ȂLCDokԂ
  } else {
    b_data = BUSY;	// rbg71ȂLCDbusyԂ
  }
  return(b_data);
}
